export interface SignalBinding {
    detach(): void;
}
export declare type SignalCallback<T> = (param: T) => void;
export declare class Signal<T = never> {
    private head?;
    private tail?;
    private isDispatching;
    private detachAllFlag;
    private detachRequests?;
    private addRequests?;
    add(callback: SignalCallback<T>, context?: any, once?: boolean): SignalBinding;
    addOnce(callback: SignalCallback<T>, context?: any): SignalBinding;
    dispatch(param?: T): void;
    detachAll(): void;
    private doAdd;
    private processDetachRequests;
    private processAddRequests;
    private removeBinding;
    private doRemoveBinding;
}
